use egui::{Color32, Label, RichText};
use crate::built_info;

/// Shows information about the program.
/// you know, the normal boring stuff
/// Shows:
/// - cool ascii logo
/// - commit number / build hash or something
/// - link to repo
/// - contributors
/// - random shit
pub fn about_ui(ui: &mut egui::Ui) {
    // Show cool ascii logo
    // TODO: make this not wrap or truncate with ...
    // double TODO: replace the logo with a cool ascii art of actual yams (vegetable) with text
    let cool_logo = RichText::new("
▓██   ██▓ ▄▄▄       ███▄ ▄███▓  ██████ 
 ▒██  ██▒▒████▄    ▓██▒▀█▀ ██▒▒██    ▒ 
  ▒██ ██░▒██  ▀█▄  ▓██    ▓██░░ ▓██▄   
  ░ ▐██▓░░██▄▄▄▄██ ▒██    ▒██   ▒   ██▒
  ░ ██▒▓░ ▓█   ▓██▒▒██▒   ░██▒▒██████▒▒
   ██▒▒▒  ▒▒   ▓▒█░░ ▒░   ░  ░▒ ▒▓▒ ▒ ░
 ▓██ ░▒░   ▒   ▒▒ ░░  ░      ░░ ░▒  ░ ░
 ▒ ▒ ░░    ░   ▒   ░      ░   ░  ░  ░  
 ░ ░           ░  ░       ░         ░  
 ░ ░                                   
    ")
        .monospace();

    // Change the colour to green if it's a release build.
    let color = if built_info::PROFILE == "release" {
        Color32::DARK_GREEN
    } else {
        Color32::DARK_RED
    };
    
    ui.add(Label::new(cool_logo.color(color)));

    ui.separator();

    ui.label(egui::RichText::new("Build Information").heading().strong());
    
    // Debug info
    // TODO: use the text layout more directly, allow for bold midway through the message (the actual info)
    ui.label(format!("Version {}-{} ({}), built for {} with {}. \nBuilt on {}",
        built_info::PKG_VERSION,
        built_info::PROFILE,
        built_info::GIT_COMMIT_HASH_SHORT.unwrap_or_default(),
        built_info::TARGET,
        built_info::RUSTC_VERSION,
        built_info::BUILT_TIME_UTC
    ));


    // Show link to repo
    ui.hyperlink("https://git.volkor.me/Volkor/yams");

    // Show authors/contributors
    ui.label(format!("Contributors: {}", built_info::PKG_AUTHORS));
}